using System.Collections.Generic;
using System.Linq;

using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ҽ Ʈ
        /// </summary>
        private List<string> sourceList = new List<string>()
        {
            "Abyssinian",
            "Aegean",
            "American Bobtail",
            "American Curl",
            "American Ringtail",
            "American Shorthair",
            "American Wirehair",
            "Aphrodite Giant",
            "Arabian Mau",
            "Asian cat",
            "Asian Semi-longhair",
            "Australian Mist",
            "Balinese",
            "Bambino",
            "Bengal",
            "Birman",
            "Brazilian Shorthair",
            "British Longhair",
            "British Shorthair",
            "Burmese",
            "Burmilla",
            "California Spangled",
            "Chantilly-Tiffany",
            "Chartreux",
            "Chausie",
            "Colorpoint Shorthair",
            "Cornish Rex",
            "Cymric",
            "Cyprus",
            "Devon Rex",
            "Donskoy",
            "Dragon Li",
            "Dwelf",
            "Egyptian Mau",
            "European Shorthair",
            "Exotic Shorthair",
            "Foldex",
            "German Rex",
            "Havana Brown",
            "Highlander",
            "Himalayan",
            "Japanese Bobtail",
            "Javanese",
            "Kanaani",
            "Khao Manee",
            "Kinkalow",
            "Korat",
            "Korean Bobtail",
            "Korn Ja",
            "Kurilian Bobtail",
            "Lambkin",
            "LaPerm",
            "Lykoi",
            "Maine Coon",
            "Manx",
            "Mekong Bobtail",
            "Minskin",
            "Napoleon",
            "Munchkin",
            "Nebelung",
            "Norwegian Forest Cat",
            "Ocicat",
            "Ojos Azules",
            "Oregon Rex",
            "Persian (modern)",
            "Persian (traditional)",
            "Peterbald",
            "Pixie-bob",
            "Ragamuffin",
            "Ragdoll",
            "Raas",
            "Russian Blue",
            "Russian White",
            "Sam Sawet",
            "Savannah",
            "Scottish Fold",
            "Selkirk Rex",
            "Serengeti",
            "Serrade Petit",
            "Siamese",
            "Siberian orSiberian Forest Cat",
            "Singapura",
            "Snowshoe",
            "Sokoke",
            "Somali",
            "Sphynx",
            "Suphalak",
            "Thai",
            "Thai Lilac",
            "Tonkinese",
            "Toyger",
            "Turkish Angora",
            "Turkish Van",
            "Turkish Vankedisi",
            "Ukrainian Levkoy",
            "Wila Krungthep",
            "York Chocolate"
        };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.autoSuggestBox.TextChanged      += autoSuggestBox_TextChanged;
            this.autoSuggestBox.QuerySubmitted   += autoSuggestBox_QuerySubmitted;
            this.autoSuggestBox.SuggestionChosen += autoSuggestBox_SuggestionChosen;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region ڵ  ڽ ؽƮ  óϱ - autoSuggestBox_TextChanged(sender, e)

        /// <summary>
        /// ڵ  ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void autoSuggestBox_TextChanged(AutoSuggestBox sender, AutoSuggestBoxTextChangedEventArgs e)
        {
            if(e.Reason == AutoSuggestionBoxTextChangeReason.UserInput)
            {
                List<string> searchList = GetSearchList(sender.Text);

                if(searchList.Count > 0)
                {
                    sender.ItemsSource = searchList;
                }
                else
                {
                    sender.ItemsSource = new string[] { "No results found" };
                }
            }
        }

        #endregion
        #region ڵ  ڽ   óϱ - autoSuggestBox_QuerySubmitted(sender, e)

        /// <summary>
        /// ڵ  ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void autoSuggestBox_QuerySubmitted(AutoSuggestBox sender, AutoSuggestBoxQuerySubmittedEventArgs e)
        {
            if(e.ChosenSuggestion != null && e.ChosenSuggestion is string)
            {
                Select(e.ChosenSuggestion as string);
            }
            else if(!string.IsNullOrEmpty(e.QueryText))
            {
                List<string> searchList = GetSearchList(sender.Text);

                if(searchList.Count > 0)
                {
                    Select(searchList.FirstOrDefault());
                }
            }
        }

        #endregion
        #region ڵ  ڽ  ý óϱ - autoSuggestBox_SuggestionChosen(sender, e)

        /// <summary>
        /// ڵ  ڽ  ý óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void autoSuggestBox_SuggestionChosen(AutoSuggestBox sender, AutoSuggestBoxSuggestionChosenEventArgs e)
        {
            this.outputTextBlock.Text = e.SelectedItem.ToString();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ȸ Ʈ ϱ - GetSearchList(text)

        /// <summary>
        /// ȸ Ʈ ϱ
        /// </summary>
        /// <param name="text">ؽƮ</param>
        /// <returns>ȸ Ʈ</returns>
        private List<string> GetSearchList(string text)
        {
            List<string> searchList = new List<string>();

            if(string.IsNullOrWhiteSpace(text))
            {
                return searchList;
            }

            string[] tokenArray = text.ToLower().Split(" ");

            foreach(string source in this.sourceList)
            {
                bool found = tokenArray.All
                (
                    (key) =>
                    {
                        return source.ToLower().Contains(key);
                    }
                );

                if(found)
                {
                    searchList.Add(source);
                }
            }

            return searchList;
        }

        #endregion
        #region ϱ - Select(name)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="name">Ī</param>
        private void Select(string name)
        {
            if(string.IsNullOrWhiteSpace(name))
            {
                this.outputTextBlock.Text = name;
            }
        }

        #endregion
    }
}